## net.sf.saxon.functions
Class Document

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.functions.SystemFunction
                  net.sf.saxon.functions.Document

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, XSLTFunction, InstructionInfo, org.xml.sax.Locator

    public class Document

extends SystemFunction
implements XSLTFunction

Implements the XSLT document() function

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.functions.SystemFunction
`operation`

Fields inherited from class net.sf.saxon.expr.FunctionCall
`argument`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, staticProperties`

Constructor Summary
`Document()`

Method Summary
`PathMap.PathMapNodeSet` `addToPathMap(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` Add a representation of this expression to a PathMap.
`void` `checkArguments(ExpressionVisitor visitor)` Method called during static type checking
`int` `computeCardinality()` Determine the static cardinality
`int` `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`Expression` `copy()` Copy an expression.
`java.lang.String` `getStaticBaseURI()` Get the base URI from the static context
`boolean` `isReadOnce()` Ask whether this document has been marked as being read once only.
`SequenceIterator` `iterate(XPathContext context)` iterate() handles evaluation of the function: it returns a sequence of Document nodes
`static NodeInfo` `makeDoc(java.lang.String href, java.lang.String baseURI, XPathContext c, javax.xml.transform.SourceLocator locator)` Supporting routine to load one external document given a URI (href) and a baseURI.
`Expression` `preEvaluate(ExpressionVisitor visitor)` preEvaluate: the document() function can be evaluated at compile time if (a) the argument is a string literal, and (b) the option `FeatureKeys.PRE_EVALUATE_DOC_FUNCTION` is set.
`static NodeInfo` `preLoadDoc(java.lang.String href, java.lang.String baseURI, Configuration config, javax.xml.transform.SourceLocator locator)` Supporting routine to load one external document given a URI (href) and a baseURI.
`static void` `sendDoc(java.lang.String href, java.lang.String baseURL, XPathContext c, javax.xml.transform.SourceLocator locator, Receiver out)` Supporting routine to push one external document given a URI (href) and a baseURI to a given Receiver.
`void` `sendDocuments(XPathContext context, Receiver out)` Copy the documents identified by this expression to a given Receiver.
`void` `setReadOnce(boolean once)` Indicate that the document(s) will be read once only (or that they should be treated as if they are read once only.

Methods inherited from class net.sf.saxon.functions.SystemFunction
`addContextDocumentArgument, addDocToPathMap, getDetails, getErrorCodeForTypeErrors, getItemType, getRequiredType, makeSystemFunction, optimize, setDetails, useContextItemAsDefault`

Methods inherited from class net.sf.saxon.expr.FunctionCall
`addExternalFunctionCallToPathMap, checkArgumentCount, equals, explain, getArguments, getDisplayName, getFunctionName, getNumberOfArguments, hashCode, iterateSubExpressions, promote, replaceSubExpression, setArguments, setFunctionName, simplify, simplifyArguments, toString, typeCheck`

Methods inherited from class net.sf.saxon.expr.Expression

`adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, display, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, evaluatePendingUpdates, explain, findParentOf, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isUpdatingExpression, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Document

    public Document()

Method Detail

### setReadOnce

    public void setReadOnce(boolean once)

  Indicate that the document(s) will be read once only (or that they should be treated as if they are read once only. This means (a) the document will not be held in memory after all references to it go out of scope, and (b) if the query or transformation tries to read it again, it will get a new copy, with different node identities, and potentially with different content. It also means that the document is eligible for document projection.

  Parameters:
    `once` - true if this document is to be treated as being read once only

### isReadOnce

    public boolean isReadOnce()

  Ask whether this document has been marked as being read once only.

  Returns:
    true if the document has been marked as being read once only

### checkArguments

    public void checkArguments(ExpressionVisitor visitor)
                        throws XPathException

  Description copied from class: `SystemFunction`
  Method called during static type checking

  Overrides:
    `checkArguments` in class `SystemFunction`
  Parameters:
    `visitor` - the expression visitor
  Throws:
    `XPathException`

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality

  Overrides:
    `computeCardinality` in class `SystemFunction`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### getStaticBaseURI

    public java.lang.String getStaticBaseURI()

  Get the base URI from the static context

  Returns:
    the base URI

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `SystemFunction`
  Returns:
    the special properties, as a bit-significant integer

### preEvaluate

    public Expression preEvaluate(ExpressionVisitor visitor)

  preEvaluate: the document() function can be evaluated at compile time if (a) the argument is a string literal, and (b) the option `FeatureKeys.PRE_EVALUATE_DOC_FUNCTION` is set.

  Overrides:
    `preEvaluate` in class `FunctionCall`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the result of the early evaluation, or the original expression, or potentially a simplified expression

### addToPathMap

    public PathMap.PathMapNodeSet addToPathMap(PathMap pathMap,
                                               PathMap.PathMapNodeSet pathMapNodeSet)

  Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

  Overrides:
    `addToPathMap` in class `Expression`
  Parameters:
    `pathMap` - the PathMap to which the expression should be added
    `pathMapNodeSet` - the set of nodes in the path map that are affected
  Returns:
    the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Overrides:
    `copy` in class `SystemFunction`
  Returns:
    the copy of the original expression

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  iterate() handles evaluation of the function: it returns a sequence of Document nodes

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### makeDoc

    public static NodeInfo makeDoc(java.lang.String href,
                                   java.lang.String baseURI,
                                   XPathContext c,
                                   javax.xml.transform.SourceLocator locator)
                            throws XPathException

  Supporting routine to load one external document given a URI (href) and a baseURI. This is used in the normal case when a document is loaded at run-time (that is, when a Controller is available)

  Parameters:
    `href` - the relative URI
    `baseURI` - the base URI
    `c` - the dynamic XPath context
    `locator` - used to identify the location of the instruction in event of error
  Returns:
    the root of the constructed document, or the selected element within the document if a fragment identifier was supplied
  Throws:
    `XPathException`

### preLoadDoc

    public static NodeInfo preLoadDoc(java.lang.String href,
                                      java.lang.String baseURI,
                                      Configuration config,
                                      javax.xml.transform.SourceLocator locator)
                               throws XPathException

  Supporting routine to load one external document given a URI (href) and a baseURI. This is used when the document is pre-loaded at compile time.

  Parameters:
    `href` - the relative URI. This must not contain a fragment identifier
    `baseURI` - the base URI
    `config` - the Saxon configuration
    `locator` - used to identify the location of the instruction in event of error. May be null.
  Returns:
    the root of the constructed document, or the selected element within the document if a fragment identifier was supplied
  Throws:
    `XPathException`

### sendDocuments

    public void sendDocuments(XPathContext context,
                              Receiver out)
                       throws XPathException

  Copy the documents identified by this expression to a given Receiver. This method is used only when it is known that the documents are being copied, because there is then no problem about node identity.

  Parameters:
    `context` - the XPath dynamic context
    `out` - the destination to which the documents will be sent
  Throws:
    `XPathException`

### sendDoc

    public static void sendDoc(java.lang.String href,
                               java.lang.String baseURL,
                               XPathContext c,
                               javax.xml.transform.SourceLocator locator,
                               Receiver out)
                        throws XPathException

  Supporting routine to push one external document given a URI (href) and a baseURI to a given Receiver. This method cannot handle fragment identifiers

  Parameters:
    `href` - the relative URI
    `baseURL` - the base URI
    `c` - the XPath dynamic context
    `locator` - used to identify the lcoation of the instruction in case of error
    `out` - the destination where the document is to be sent
  Throws:
    `XPathException`

Copyright (c) Saxonica Limited. All rights reserved.